洛谷P1126 机器人搬重物题解

我太难了qwq肝了两天,重构了一次代码。真的很菜。
算法标签:广搜
题目链接:https://www.luogu.org/problem/P1126

这题最坑的是:输入的是格子,不是点!!!需要把他转化成点图

    for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
      {
          bool a;
          cin>>a;
          if(a)
          {
          /*
          由于这是格子图,需要把坐标的上,左,上左三个格子都给变成1
          自己看看题目的那张图好好想想
          */
              map[i][j]=1;
              map[i-1][j-1]=1;
              map[i-1][j]=1;
              map[i][j-1]=1;
          }
      }

再好好看看那张图,你还会发现:尼玛边界也走不了于是:

    for(i=1;i<=n;i++)map[i][m]=1;
    for(i=1;i<=m;i++)map[n][i]=1;

有没有想过为什么只有下面和右边被封住了?因为格子变成点了,左边和上边被扩展了一个单位,所以只需要封住下面和右边就行了
其余也没什么好讲的了,就是模拟一下他的操作。
スタート:

#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
bool map[600][600];
int n,m;
char face;//初始朝向
int sx,sy,fx,fy;//起终点坐标
int head=1,tail=1;
bool vis[600][600][5];//n s e w  1 2 3 4
//vis[x][y][z] = 1 表示在(x,y)时z状态已经遍历过
int cnm;
struct step//结构体
{
    int x,y;//坐标
    char r_status;//当前状态
    int step;
    int father;//他的上一个状态,调试用
}a[500000];//多开点,不然第九个点会溢出
void init()
{
    int i,j;
    scanf("%d%d",&n,&m);
    for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
      {
          bool a;
          cin>>a;
          if(a)
          {
              map[i][j]=1;
              map[i-1][j-1]=1;
              map[i-1][j]=1;
              map[i][j-1]=1;
          }
	}
    cin>>sx>>sy>>fx>>fy>>face;
}
bool in_map(int x,int y){if(x<1 || y<1 || x>n || y>m)return true;return false;}
int charts(char x)
{
	//人为地将东南西北转化成1 2 3 4 
    if(x =='N')return 1;
    else if(x =='S')return 2;
    else if(x =='W')return 3;
    else return 4;
}
int charts_x(int x,int status)
{
    if(status == 1)return -x;
    else if(status == 2)return x;
    else return 0;
}
int charts_y(int x,int status)
{
    if(status == 3)return -x;
    else if(status == 4)return x;
    else return 0;
}
bool you_can_go_there(int code)//判断当前状态地点在走code步时会不会遇到障碍
{
    int i;
    int tmpx=a[head].x;
    int tmpy=a[head].y;
    char ss =a[head].r_status;
    for(i=1;i<=code;i++)
    {
        if(ss == 'N' && map[tmpx-i][tmpy])return 1;
        if(ss == 'S' && map[tmpx+i][tmpy])return 1;
        if(ss == 'W' && map[tmpx][tmpy-i])return 1;
        if(ss == 'E' && map[tmpx][tmpy+i])return 1;
    }
    return 0;
}
void creep()//这几个操作函数一样,就是前进的步数不一样
{
	//简化写代码的工作量
    int xx = a[head].x;
    int yy = a[head].y;
    char ss = a[head].r_status;
    int sss = charts(ss);//主要判断vis[][][]用
	//通过这个函数直接获得下一个状态的坐标,少些4个if
    int n_xx = xx+charts_x(1,sss);
    int n_yy = yy+charts_y(1,sss);

    if(vis[n_xx][n_yy][sss] || in_map(n_xx,n_yy) || you_can_go_there(1))return;
    vis[n_xx][n_yy][sss] = 1;
    a[tail].r_status = ss;
    a[tail].x = n_xx;
    a[tail].y = n_yy;
    a[tail].step = a[head].step + 1;
    // just to save load
    a[tail].father = head;
    tail++;
}
void walk()
{
    int xx = a[head].x;
    int yy = a[head].y;
    char ss = a[head].r_status;
    int sss = charts(ss);

    int n_xx = xx+charts_x(2,sss);
    int n_yy = yy+charts_y(2,sss);
    if(vis[n_xx][n_yy][sss] || in_map(n_xx,n_yy) || you_can_go_there(2))return;
    vis[n_xx][n_yy][sss] = 1;
    a[tail].r_status = ss;
    a[tail].x = n_xx;
    a[tail].y = n_yy;
    a[tail].step = a[head].step + 1;
    // just to save load
    a[tail].father = head;
    tail++;
}
void run()
{ 
    int xx = a[head].x;
    int yy = a[head].y;
    char ss = a[head].r_status;
    int sss = charts(ss);

    int n_xx = xx+charts_x(3,sss);
    int n_yy = yy+charts_y(3,sss);
    if(vis[n_xx][n_yy][sss] || in_map(n_xx,n_yy) || you_can_go_there(3))return;
    vis[n_xx][n_yy][sss] = 1;
    a[tail].r_status = ss;
    a[tail].x = n_xx;
    a[tail].y = n_yy;
    a[tail].step = a[head].step + 1;
    // just to save load
    a[tail].father = head;
    tail++;
}
char turn_it_right(int sss)
{
    if(sss == 1)return 'E';
    else if(sss == 2)return 'W';
    else if(sss == 3)return 'N';
    else return 'S';
}
char turn_it_left(int sss)
{
    if(sss == 1)return 'W';
    else if(sss == 2)return 'E';
    else if(sss == 3)return 'S';
    else return 'N';
}
void turn_left()
{
    int xx = a[head].x;
    int yy = a[head].y;
    char ss = a[head].r_status;
    int sss = charts(ss);
    char n_s= turn_it_left(sss);//寻找下一个坐标
    sss = charts(n_s);

    if(vis[xx][yy][sss])return;
    vis[xx][yy][sss] = 1;
    a[tail].r_status = n_s;
    a[tail].x = xx;
    a[tail].y = yy;
    a[tail].step = a[head].step + 1;
    // just to save load
    a[tail].father = head;
    tail++;
}
void turn_right()
{
    int xx = a[head].x;
    int yy = a[head].y;
    char ss = a[head].r_status;
    int sss = charts(ss);
    char n_s= turn_it_right(sss);
    sss = charts(n_s);

    if(vis[xx][yy][sss])return;
    vis[xx][yy][sss] = 1;
    a[tail].r_status = n_s;
    a[tail].x = xx;
    a[tail].y = yy;
    a[tail].step = a[head].step + 1;
    // just to save load
    a[tail].father = head;
    tail++;
}
void bfs()
{
	//初始化队列
    a[1].x = sx;
    a[1].y = sy;
    a[1].r_status = face;
    vis[sx][sy][charts(face)]=1;
    tail++;
    while(head<tail)
    {
        int xx = a[head].x;
        int yy = a[head].y;
        char ss = a[head].r_status;
        int sss = charts(ss);
        vis[xx][yy][sss] = 1;
        if(a[head].x == fx && a[head].y == fy){printf("%d",a[head].step);cnm=2;return;}
        creep();
        walk();
        run();
        turn_right();
        turn_left();
        head++;
    }
}

void fuck()
{
    int i;
    for(i=1;i<=n;i++)map[i][m]=1;
    for(i=1;i<=m;i++)map[n][i]=1;
}
int main()
{
    init();
    fuck();
    if(map[sx][sy]){printf("-1");return 0;}
    bfs();
    if(cnm==2)return 0;//有结果就直接结束
    printf("-1");//第八个点是-1
    return 0;
}

在这里插入图片描述

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
对于洛谷上的p1036目,我们可以使用Python来解决。下面是一个可能的解法: ```python def dfs(nums, target, selected_nums, index, k, sum): if k == 0 and sum == target: return 1 if index >= len(nums) or k <= 0 or sum > target: return 0 count = 0 for i in range(index, len(nums)): count += dfs(nums, target, selected_nums + [nums[i]], i + 1, k - 1, sum + nums[i]) return count if __name__ == "__main__": n, k = map(int, input().split()) nums = list(map(int, input().split())) target = int(input()) print(dfs(nums, target, [], 0, k, 0)) ``` 在这个解法中,我们使用了深度优先搜索(DFS)来找到满足要求的数列。通过递归的方式,我们遍历了所有可能的数字组合,并统计满足条件的个数。 首先,我们从给定的n和k分别表示数字个数和需要选取的数字个数。然后,我们输入n个数字,并将它们存储在一个列表nums中。接下来,我们输入目标值target。 在dfs函数中,我们通过迭代index来选择数字,并更新选取的数字个数k和当前总和sum。如果k等于0且sum等于target,我们就找到了一个满足条件的组合,返回1。如果index超出了列表长度或者k小于等于0或者sum大于target,说明当前组合不满足要求,返回0。 在循环中,我们不断递归调用dfs函数,将选取的数字添加到selected_nums中,并将index和k更新为下一轮递归所需的值。最终,我们返回所有满足条件的组合个数。 最后,我们在主程序中读入输入,并调用dfs函数,并输出结果。 这是一种可能的解法,但不一定是最优解。你可以根据目要求和测试数据进行调试和优化。希望能对你有所帮助!
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值